package com.example.restcache;

import java.io.IOException;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.ApplicationScoped;

import org.infinispan.manager.DefaultCacheManager;

@ApplicationScoped
public class CacheManagerService {
    private DefaultCacheManager instance = null;

    @PostConstruct
    public void init() throws IOException{
    	if (instance == null) {
            instance = new DefaultCacheManager("infinispan.xml");
        }
    }

    @PreDestroy
    public void stop() {
        if (instance != null) {
            instance.stop();
            instance = null;
        }
    }

    public DefaultCacheManager cacheManager() {
        return instance;
    }
}
